package com.takensoft.taken_bi_manager.common.config.filter;

import java.io.IOException;
import java.util.HashMap;

import org.springframework.web.filter.GenericFilterBean;
import org.springframework.web.util.ContentCachingResponseWrapper;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.takensoft.taken_bi_manager.common.util.AuthUtil;
import com.takensoft.taken_bi_manager.common.vo.CustomeResultMap;

import jakarta.servlet.FilterChain;
import jakarta.servlet.ServletException;
import jakarta.servlet.ServletRequest;
import jakarta.servlet.ServletResponse;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;

public class SessionCheck extends GenericFilterBean {

	@Override
	public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain)
		 throws IOException, ServletException {		
	
		 HttpServletRequest  httpServletRequest = (HttpServletRequest)request;
		 String uri =httpServletRequest.getRequestURI().toString();		 
		 
		 // 로그인 세션 처리 (없으면 세션 없음 메세지 전달)
		 if(!uri.trim().contains("/login")) {
			 HashMap<String, Object> LoginUserInfo = (HashMap<String, Object>)httpServletRequest.getSession().getAttribute(AuthUtil.LOGIN_USER_SESSION);
			 if(LoginUserInfo == null) {
				 ContentCachingResponseWrapper responseWrapper = new ContentCachingResponseWrapper((HttpServletResponse) response);
				 chain.doFilter(request, responseWrapper);
				 CustomeResultMap map = new CustomeResultMap();
				 map.getCheckMessage().setError("로그인 정보가 없습니다.");
				 map.getCheckMessage().setStatus(100);
				 map.getCheckMessage().setSuccess(false);
				 
				 String newResponse = new ObjectMapper().writeValueAsString(map);
			     response.setContentType("application/json");
			     response.setContentLength(newResponse.length());
			     response.getOutputStream().write(newResponse.getBytes());				
			 }else {
				 System.out.println("세션있음");
				 System.out.println(LoginUserInfo.get("user_id"));
				 chain.doFilter(request, response);
			 }
		 }		 
        
	}

}
