package com.takensoft.taken_bi_manager.common.connection.api.vo;



import java.io.Serializable;

import lombok.Getter;
import lombok.Setter;

/**
 * @author 김성원
 * @since 2021.11.02
 * 
 * Api 커넥션의 파라미터 정보를 담습니다. 
 */
@Getter
@Setter
public class ApiParam implements Serializable {
	
	/**
	 * 시리얼 버전
	 */	
	private static final long serialVersionUID = 1L;

	/**
	 * 파라미터 DB저장 Key값
	 */
	private String paramId;	
	
	/**
	 *  파라미터 순서
	 */
	private int index;
	
	/**
	 * 파라미터 Key값
	 */
	private String key;
	
	/**
	 * 파라미터 value값
	 */
	private Object value;
	
	/**
	 * encode 제외 변수
	 */
	private boolean disableDecode;
	
	/**
	 * 날짜계산 변수
	 */
	private boolean dateForm = false;	
	
	
	/**
	 * 날자 제어 타입(year, month, day) 
	 */
	private String dateType;
	
	/**
	 * 날자 제어변수 
	 */
	private int addDate = 0;

	
	public static long getSerialversionuid() {
		return serialVersionUID;
	}
	
}
