package com.takensoft.taken_bi_manager.common.connection.api.vo;


import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


import lombok.Getter;
import lombok.Setter;

/**
 * @author 김성원
 * @since 2021.11.02
 * 
 * Api 커넥션 정보를 담는 Class 
 */
@Getter
@Setter
public class ConnectionApi implements Serializable {

	
	/**
	 * 연계 PAI 제목
	 */	
	private String title;
	
	/**
	 * 연계 url
	 */	
	private String url;

	/**
	 * 연계 타입 1 = json, 2=xml
	 */	
	private int type;
	
	/**
	 * 연계 타입 1 = post, 2 = get
	 */	
	private int requestType;
	
	/**
	 * 연계 결과
	 */	
	private String result;
	
	/**
	 * 뎁스설정  구분자 > 
	 */	
	private String depth;
	
	/**
	 * 파라미터 리스트
	 */	
	private List<ApiParam> params = new  ArrayList<ApiParam>();
	
	/**
	 * 데이터(행,열)의 컬럼인 Row의 Index
	 */
	private int rowDataColumnIndex;
	
	/**
	 * 데이터(행,열)의 Row 시작 Index
	 */
	private int startRowIndex;
	
	/**
	 * 데이터(행,열)의 Cell 시작 Index
	 */
	private int startCellIndex;
	
	public ConnectionApi() {
		this.params = new ArrayList<ApiParam>();
		this.type = 1;
	}	

	
	public Map<String, Object> paramstoMap(){
		Map<String, Object> result = new HashMap<String,Object>();
		
		// this.params -> map 
		for(int i=0; i< this.params.size(); i++	) {
			result.put(this.params.get(i).getKey(), this.params.get(i).getValue());
		}
		
		return result;
	}
	
}
