package com.takensoft.taken_bi_manager.common.connection.db.dao;


import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import org.apache.ibatis.mapping.ParameterMapping;
import org.mybatis.spring.SqlSessionTemplate;

import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.takensoft.taken_bi_manager.common.connection.db.util.DBConnectionConfig;
import com.takensoft.taken_bi_manager.common.connection.db.vo.ConnectionDB;
import com.takensoft.taken_bi_manager.common.connection.db.vo.TableBasicInfo;
import com.takensoft.taken_bi_manager.common.util.StringUtil;
import com.takensoft.taken_bi_manager.data.vo.ColumnData;
import com.takensoft.taken_bi_manager.data.vo.DataTable;
import com.takensoft.taken_bi_manager.data.vo.Dataset;



public class PostgresqlDAO  extends DatabaseDAO {

	public PostgresqlDAO () {}
	
	public PostgresqlDAO (ConnectionDB db) throws Exception {
		this.createConnector(db);
	}
	
	private DBConnectionConfig dbUtil = null;
	
	public DBConnectionConfig getDbUtil() {
		return dbUtil;
	}
	public void setDbUtil(DBConnectionConfig dbUtil) {
		this.dbUtil = dbUtil;
	}
	
	
	@Override
	public void createConnector(ConnectionDB db) throws Exception {
		// TODO Auto-generated method stub
		dbUtil = new DBConnectionConfig();
		dbUtil.mybatisSqlTemplateCreate(db);
	}

	@Override
	public List<Dataset> getDBConnectionTableList(ConnectionDB db) throws Exception {
		// TODO Auto-generated method stub
		try {
			return dbUtil.getTemplate().selectList("PostgresqlDAO.getDBConnectionTableList", db);
		} catch (Exception e) {
			return new ArrayList<Dataset>();
		}
	}

	@Override
	public List<ColumnData> getDBConnectionTableColumnList(Dataset dataset) throws Exception {
		// TODO Auto-generated method stub
		return dbUtil.getTemplate().selectList("PostgresqlDAO.getDBConnectionTableColumnList", dataset);
	}

	@Override
	public List<LinkedHashMap<String, Object>> getDBConnectionTableDataList(DataTable datatable) throws Exception {
		// TODO Auto-generated method stub
		return dbUtil.getTemplate().selectList("PostgresqlDAO.getDBConnectionTableDataList", datatable);
	}

	@Override
	public int getDBConnectionTableDataTotalRows(DataTable datatable) throws Exception {
		// TODO Auto-generated method stub
		return dbUtil.getTemplate().selectOne("PostgresqlDAO.getDBConnectionTableDataTotalRows", datatable);
	}

	@Override
	public List<LinkedHashMap<String, Object>> getDBConnectionCustomQueryDataList(DataTable datatable)
			throws Exception {
		// TODO Auto-generated method stub
		return dbUtil.getTemplate().selectList("PostgresqlDAO.getDBConnectionCustomQueryDataList", datatable);
	}

	@Override
	public int executeCustomQuery(DataTable datatable) throws Exception {
		// TODO Auto-generated method stub
		return dbUtil.getTemplate().update("PostgresqlDAO.executeCustomQueryDataList", datatable);
	}

	@Override
	public int getDBConnectionCustomQueryDataTotalRows(DataTable datatable) throws Exception {
		// TODO Auto-generated method stub
		return dbUtil.getTemplate().selectOne("PostgresqlDAO.getDBConnectionCustomQueryDataTotalRows", datatable);
	}

	@Override
	public List<LinkedHashMap<String, Object>> getDBCollectionQueryDataList(DataTable datatable) throws Exception {
		// TODO Auto-generated method stub
		return dbUtil.getTemplate().selectList("PostgresqlDAO.getDBCollectionQueryDataList", datatable);
	}

	@Override
	public int getDBCollectionQueryDataTotalRows(DataTable datatable) throws Exception {
		// TODO Auto-generated method stub
		return dbUtil.getTemplate().selectOne("PostgresqlDAO.getDBCollectionQueryDataTotalRows", datatable);
	}

	@Override
	public int getCustomQueryPrimaryOverlapCount(DataTable datatable) throws Exception {
		// TODO Auto-generated method stub
		return dbUtil.getTemplate().selectOne("getCustomQueryPrimaryOverlapCount.getCustomQueryPrimaryOverlapCount", datatable);
	}

	@Override
	public void dbConnectionClose() throws Exception {
		dbUtil.close();
	}

	@Override
	public String getQuery(String id, Object parameter) throws Exception {
		SqlSessionTemplate template = dbUtil.getTemplate();
		
		id = "PostgresqlDAO." + id;
		
	    String sql = template.getConfiguration().getMappedStatement(id).getBoundSql(parameter).getSql();
	    List<ParameterMapping> paramMap = template.getConfiguration().getMappedStatement(id).getBoundSql(parameter).getParameterMappings();
	    
	    ObjectMapper mapper = new ObjectMapper();
	    String json = mapper.writeValueAsString(parameter);
	    HashMap<String, Object> params = mapper.readValue(json, new TypeReference<HashMap<String, Object>>(){});
	    for (ParameterMapping par : paramMap) {
	        String param = StringUtil.toString(params.get(par.getProperty()));
	        if(parameter == null)
	            sql = sql.replaceFirst("\\?", "NULL");
	        else
	            sql = sql.replaceFirst("\\?", "'" + param + "'");
	    }
	    System.out.println("");
	    System.out.println("---------------------- PostGresqlDAO sql --------------------");
	    System.out.println(sql);
	    System.out.println("");
	    return sql;
	}

	@Override
	public int datasetTableCreate(DataTable datatable) throws Exception {
		// TODO Auto-generated method stub
		return dbUtil.getTemplate().update("PostgresqlDAO.datasetTableCreate", datatable);
	}

	@Override
	public int datasetDefaultTableCreate(DataTable datatable) throws Exception {
		// TODO Auto-generated method stub
		return dbUtil.getTemplate().update("PostgresqlDAO.datasetDefaultTableCreate", datatable);
	}

	@Override
	public void datasetDataUpdate(DataTable datatable) throws Exception {
		// TODO Auto-generated method stub
		dbUtil.getTemplate().update("PostgresqlDAO.datasetDataUpdate", datatable);
	}

	@Override
	public void datasetDataDelete(DataTable datatable) throws Exception {
		// TODO Auto-generated method stub
		dbUtil.getTemplate().update("PostgresqlDAO.datasetDataUpdate", datatable);
	}

	@Override
	public int duplicateCheckTableName(Map info) throws Exception {
		// TODO Auto-generated method stub
		return dbUtil.getTemplate().selectOne("PostgresqlDAO.duplicateCheckTableName", info);
	}

	@Override
	public List<LinkedHashMap<String, Object>> getRowData(DataTable dataTable) throws Exception {
		// TODO Auto-generated method stub
		return dbUtil.getTemplate().selectList("PostgresqlDAO.getRowData", dataTable);
	}

	@Override
	public List<LinkedHashMap<String, Object>> getRowDataAll(DataTable dataTable) throws Exception {
		// TODO Auto-generated method stub
		
		ObjectMapper mapper = new ObjectMapper();
		System.out.println("dataTable :::: " + mapper.writeValueAsString(dataTable));
		
		return dbUtil.getTemplate().selectList("PostgresqlDAO.getRowDataAll", dataTable);		
	}

	@Override
	public int getRowDataTotalRows(DataTable dataTable) throws Exception {
		// TODO Auto-generated method stub
		return dbUtil.getTemplate().selectOne("PostgresqlDAO.getRowDataTotalRows", dataTable);
	}

	@Override
	public int emptyDataset(DataTable dataTable) throws Exception {
		// TODO Auto-generated method stub
		return dbUtil.getTemplate().delete("PostgresqlDAO.emptyDataset", dataTable);
	}

	@Override
	public int tableColumnChange(TableBasicInfo tableBasicInfo) throws Exception {
		// TODO Auto-generated method stub
		ObjectMapper mapper = new ObjectMapper();
		
		System.out.println("tableColumnChange" + mapper.writeValueAsString(tableBasicInfo));
		return dbUtil.getTemplate().update("PostgresqlDAO.tableColumnChange", tableBasicInfo);	
	}

	@Override
	public int changePrimaryKey(TableBasicInfo tableBasicInfo) throws Exception {
		// TODO Auto-generated method stub
		return dbUtil.getTemplate().update("PostgresqlDAO.changePromaryKey", tableBasicInfo);	
	}

	@Override
	public int createAutoIncrement(TableBasicInfo tableBasicInfo) throws Exception {
		// TODO Auto-generated method stub
		return dbUtil.getTemplate().update("PostgresqlDAO.createAutoIncrement", tableBasicInfo);	
	}
	

	@Override
	public void updateTableMetaInfo(DataTable dataTable) throws Exception {
		dbUtil.getTemplate().update("PostgresqlDAO.updateTableMetaInfo", dataTable);
		
	}
}
