package com.takensoft.taken_bi_manager.common.connection.db.vo;

import lombok.Getter;
import lombok.Setter;

/**
 * @author 김성원
 * @since 2024.01.04
 * 
 * 데이터 베이스 기본 정보를 담는 Class 입니다.
 */
@Getter
@Setter
public class TableBasicColumn implements Cloneable{
	
	public TableBasicColumn () {}
	
	public TableBasicColumn (TableBasicInfo tableBasicInfo) {
		this.columnName = tableBasicInfo.getColumnName();
		this.tobeColumnName = tableBasicInfo.getTobeColumnName();
		this.dataType = tableBasicInfo.getDataType();
		this.size = tableBasicInfo.getSize();
	}
	
	/**
	 * 컬럼명
	 */
	private String columnName;
	
	/**
	 * 바뀔 컬럼명
	 */
	private String tobeColumnName;
	
	/**
	 * 컬럼의 데이터 타입(DB기준)
	 */
	private String dataType;
	
	/**
	 * 컬럼의 데이터 size
	 */
	private long size;
	
	/**
	 * 해당 열의 PK인지 아닌지에 대한 여부
	 */
	private boolean isPrimary;


	
	public TableBasicColumn clone() throws CloneNotSupportedException {
        return (TableBasicColumn)super.clone();
    }

}
