package com.takensoft.taken_bi_manager.common.connection.db.vo;

import java.util.ArrayList;
import java.util.List;

import lombok.Getter;
import lombok.Setter;

/**
 * @author 김성원
 * @since 2024.01.04
 * 
 * 데이터 베이스 기본 설정 변경시 사용할 class 입니다.
 */
@Getter
@Setter
public class TableBasicInfo {
	
	public TableBasicInfo () {}
	
	public TableBasicInfo (String databaseName, String tableName, String columnName) {
		this.databaseName = databaseName;
		this.tableName = tableName;
		this.columnName = columnName;
	}

	/**
	 * 데이터 베이스 명 (스키마명)
	 */
	private String databaseName;
	
	/**
	 * 데이터 베이스 접속 아이디
	 */
	private String id;
	
	/**
	 * 테이블명
	 */
	private String tableName;
	
	/**
	 * 컬럼명
	 */
	private String columnName;
	
	/**
	 * 바뀔 컬럼명
	 */
	private String tobeColumnName;
	
	/**
	 * 컬럼의 데이터 타입(DB기준)
	 */
	private String dataType;
	
	/**
	 * 컬럼의 데이터 size
	 */
	private long size;
	
	/**
	 * 해당 열의 PK인지 아닌지에 대한 여부
	 */
	private boolean isPrimary;
		
	/**
	 * PK 리스트 
	 */
	private List<String> primaryList;		
	
	/**
	 * PK 리스트 
	 */
	private String process;
		

	/**
	 * 컬럼의 데이터 목록
	 */
	List<TableBasicColumn> tableBasicColumns = new ArrayList<TableBasicColumn>(); 

	

}
