package com.takensoft.taken_bi_manager.common.file.vo;

import java.io.File;

import lombok.Getter;
import lombok.Setter;

/**
 * @author 김성원
 * @since 2024.01.12
 * 
 * 파일변환 관련 Object입니다. 
 */
@Getter
@Setter
public class FileInfo {
	
	
	/**
	 * 생성자(파일)
	 */
	public FileInfo(File file) {
		this.file = file;
	}
	
	/**
	 * 생성자(파일, 확장자)
	 */
	public FileInfo(File file, String fileFome) {
		this.file = file;
		this.fileFom = fileFome;
	}
	
	
	/**
	 * 생성자(파일및, 확장자, 구분자)
	 */
	public FileInfo(File file, String fileFome, String suffix) {
		this.file = file;
		this.fileFom = fileFome;
		this.suffix = suffix;
		
	}
	

	/** 
	 * 관리 파일
	 */
	private File file;	
	
	/**
	 *  파일 명
	 */
	private String fileName;

	
	/**
	 *  파일 수집 타입 : 전체, 포함, 특정
	 */
	private String type;	
	
	/**
	 *  마지막  파일 옵션
	 */
	private boolean lastData;
	
	/**
	 *  데이터셋 업데이트 보다 최신 파일만 선택 옵션
	 */
	private boolean datasetAfter;	
	
	/**
	 *  데이터셋 아이디
	 */
	private String datasetId;
	
	/**
	 * 데이터(행,열)의 컬럼인 Row의 Index
	 */
	private int rowDataColumnIndex;
	
	/**
	 * 데이터(행,열)의 Row 시작 Index
	 */
	private int startRowIndex;
	
	/**
	 * 데이터(행,열)의 Cell 시작 Index
	 */
	private int startCellIndex;
	
	/**
	 *  파일 쓰기 옵션
	 */
	private boolean streOptn = true;
	
	/**
	 *   파일 타입 : xlsx, xls, csv, text, json, xml ... 
	 */
	private String fileFom = "xlsx";
	
	/**
	 *  날짜시간 형식
	 */
	private String suffix = "_YYYYMMDDHHmmss";
	
	/**
	 * 일계산
	 */
	private int addDay = 0;	
	
	/**
	 * file 구분자
	 */
	private String delimiter = ",";	
	

	
}
