package com.takensoft.taken_bi_manager.common.file.vo;


import java.sql.Timestamp;
import java.util.Date;

import com.takensoft.taken_bi_manager.common.vo.SystemCode.FileType;

import lombok.Getter;
import lombok.Setter;



/**
 * @author 김성원
 * @since 2023.12.29
 * 
 * File 관리 Domain 입니다.
 */
@Getter
@Setter
public class FileManage {
	
	public FileManage() {};
	
	public FileManage(String fileManagerId) {
		this.fileManagerId = fileManagerId;
	};
	
	public FileManage(long fileSeq) {
		this.fileId = fileSeq;
	};
	
	public FileManage(String fileManagerId, long fileSeq) {
		this.fileManagerId = fileManagerId;
		this.fileId = fileSeq;
	};
	
	public FileManage(FileType fileType) {
		this.fileType = fileType;
	};
	
	public FileManage(FileType fileType, String contentType) {
		this.fileType = fileType;
		this.contentType = contentType;
	};
	
	public FileManage(String fileManagerId, FileType fileType) {
		this.fileManagerId = fileManagerId;
		this.fileType = fileType;
	};
	
	public FileManage(String fileManagerId, FileType fileType, String contentType) {
		this.fileManagerId = fileManagerId;
		this.fileType = fileType;
		this.contentType = contentType;
	};

	/**
	 * 파일 관리 아이디
	 */
	private String fileManagerId;
	
	/**
	 * 파일 타입
	 */
	private FileType fileType;
	
	/**
	 * 등록한 컨텐츠 타입
	 */
	private String contentType;
	
	/**
	 * 파일 SEQ
	 */
	private long fileId;

	/**
	 * 파일명
	 */
	private String name;

	/**
	 * 마스크 파일명
	 */
	private String maskName;

	/**
	 * 파일 사이즈.
	 */
	private long size;

	/**
	 * 서브 디렉토리.
	 */
	private String subDir;
	
	/**
	 * 데이터 셋 파일 절대 경로
	 */
	private String fullDir;

	/**
	 * 파일 확장자.
	 */
	private String extension;

	/**
	 * 파일 생성일.
	 */
	private Date createDate;
	
	
	
	
	
	/**
	 * file 관련 메세지
	 */
	//private CheckMessage checkMessage = new CheckMessage();	

//	public CheckMessage getCheckMessage() {
//		return checkMessage;
//	}
//
//	public void setCheckMessage(CheckMessage checkMessage) {
//		this.checkMessage = checkMessage;
//	}


}
