package com.takensoft.taken_bi_manager.common.vo;

import java.util.ArrayList;
import java.util.List;

import lombok.Getter;
import lombok.Setter;

/**
 * @author 김성원
 * @since 2024.01.09
 * 
 * 공통 검색 VO 입니다
 */
@Getter
@Setter
public class SearchVO {
	
	/**
	 * 검색Keyword
	 */
	private List<SearchObject> searchObjectList = new ArrayList<SearchObject>();
	
	/** 
	 * 정렬 기준 (컬럼명)
	 */
	private String order = "";

	/** 
	 * 정렬 타입
	 * true - ASC
	 * false - DESC
	 */
	private boolean isOrderASC = true;
	
	/** 
	 * 현재페이지
	 */
	private int currentPage = 1;

	/** 
	 * 페이지갯수
	 */
	private int perPage = 10;
	
	/** 
	 * 총 개시물 수
	 */
	private int totalRows;
	
}
