package com.takensoft.taken_bi_manager.data.vo;

import java.io.Serializable;
import java.sql.Timestamp;

import com.takensoft.taken_bi_manager.common.vo.CommonVO;

import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
/**
 * @author 김성원
 * @since 2024.01.03
 * 
 * Dataset Domain 입니다.
 */
public class Dataset extends CommonVO implements Serializable {	

	/**
	 * 시리얼 버전
	 */
	private static final long serialVersionUID = 1L;
	
	
	// 데이터셋 아이디
	private String datasetId;
	
	// 데이터셋 명 
	private String datasetSj;
	
	// 테이블 명 
	private String tableNm;
	
	// 한글 테이블 명
	private String tableNmKr;
	
	// 테이블 생성여부
	private boolean creatTableAt;
	
	// 테이블명 표준화 여부
	private boolean stdizTableNm;	
	
	// 컬럼명 표준화 여부
	private boolean stdizColumnAt;
	
	// 도메인 표준화 여부 
	private boolean stdizDomnAt;	
	
	// 데이터 게시물 ID(FK)
	private String datasetPostId;
	
	// 생성일
	private Timestamp creatDt;
	
	// 생성자ID
	private String creatId;
	
	// 수정일 
	private Timestamp updtDt;
		
	// 수정자 ID
	private String updtId;
	
	// 커넥션 ID
	private String dbConectId;	
	
	// 사용쿼리
	private String query;	

	//  데이터베이스명	
	private String databaseNm;
	
		
	
	
	
}
