package com.takensoft.taken_bi_manager.meta.term.vo;


import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import com.takensoft.taken_bi_manager.data.vo.Column;



/**
 * @author 최정우
 * @since 2019.11.13
 * 
 * StandardTerm(표준용어) Domain 입니다.
 */
public class StandardTerm implements Serializable {

	
	/**
	 * 시리얼 버전
	 */
	private static final long serialVersionUID = 1L;
	
	/**************************** Domain 원본 ****************************/
	
	/**
	 * 표준용어 SEQ
	 */
	private long termSeq;
	
	/**
	 * 표준용어 ID (SEQ여러개 포함)
	 */
	private String termId;
	
	/**
	 * 표준용어 한글
	 */
	private String korean;

	/**
	 * 표준용어 영어
	 */
	private String english;
	
	/**
	 * 표준용어 영어 약어
	 */
	private String englishAbbr;
	
	/**
	 * 용어 설명
	 */
	private String termDc;
	
	/**
	 * 표준용어 사용 시스템
	 */
	private String usingSystem;
	
	/**
	 * 생성일
	 */
	private String createDate;
	
	/**
	 * 생성자
	 */
	private String createId;
	
	/**
	 * 수정일
	 */
	private String updateDate;
	
	/**
	 * 수정자
	 */
	private String updateId;
	
	/**
	 * 사용여부
	 */
	private boolean isUse;
	
	/**
	 * 표준 여부
	 */
	private boolean isStandard;
	
	/**
	 * 행안부 표준 여부
	 */
	private boolean isMinistryStandard;
	
	/**
	 * 한 용어에 대한 순서 (히스토리 Index)
	 */
	private int orders;
	
	/**
	 * 한 용어에 대한 검색 횟수
	 */
	private long searchCount = 0;

	public long getTermSeq() {
		return termSeq;
	}

	public void setTermSeq(long termSeq) {
		this.termSeq = termSeq;
	}

	public String getTermId() {
		return termId;
	}

	public void setTermId(String termId) {
		this.termId = termId;
	}

	public String getKorean() {
		return korean;
	}

	public void setKorean(String korean) {
		this.korean = korean;
	}

	public String getEnglish() {
		return english;
	}

	public void setEnglish(String english) {
		this.english = english;
	}

	public String getEnglishAbbr() {
		return englishAbbr;
	}

	public void setEnglishAbbr(String englishAbbr) {
		this.englishAbbr = englishAbbr;
	}

	public String getTermDc() {
		return termDc;
	}

	public void setTermDc(String termDc) {
		this.termDc = termDc;
	}

	public String getUsingSystem() {
		return usingSystem;
	}

	public void setUsingSystem(String usingSystem) {
		this.usingSystem = usingSystem;
	}

	public String getCreateDate() {
		return createDate;
	}

	public void setCreateDate(String createDate) {
		this.createDate = createDate;
	}

	public String getCreateId() {
		return createId;
	}

	public void setCreateId(String createId) {
		this.createId = createId;
	}

	public String getUpdateDate() {
		return updateDate;
	}

	public void setUpdateDate(String updateDate) {
		this.updateDate = updateDate;
	}

	public String getUpdateId() {
		return updateId;
	}

	public void setUpdateId(String updateId) {
		this.updateId = updateId;
	}

	public boolean getIsUse() {
		return isUse;
	}

	public void setIsUse(boolean isUse) {
		this.isUse = isUse;
	}

	public boolean getIsStandard() {
		return isStandard;
	}

	public void setIsStandard(boolean isStandard) {
		this.isStandard = isStandard;
	}

	public boolean getIsMinistryStandard() {
		return isMinistryStandard;
	}

	public void setIsMinistryStandard(boolean isMinistryStandard) {
		this.isMinistryStandard = isMinistryStandard;
	}

	public int getOrders() {
		return orders;
	}

	public void setOrders(int orders) {
		this.orders = orders;
	}
	
	public long getSearchCount() {
		return searchCount;
	}

	public void setSearchCount(long searchCount) {
		this.searchCount = searchCount;
	}
	
	/**************************** Domain 원본 ****************************/

	/**
	 * 컬럼 ID
	 */
	private String columnId;
	
	/**
	 * 해당 용어와 연결된 컬럼 목록입니다.
	 */
	private List<Column> columns = new ArrayList<Column>();

	public List<Column> getColumns() {
		return columns;
	}

	public void setColumns(List<Column> columns) {
		this.columns = columns;
	}

	public String getColumnId() {
		return columnId;
	}

	public void setColumnId(String columnId) {
		this.columnId = columnId;
	}
	
}
