package com.takensoft.taken_bi_manager.meta.term.vo;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;


/**
 * @author 최정우
 * @since 2019.11.13
 * 
 * 표준용어 검색 결과 VO 입니다.
 */
public class StandardTermSearch implements Serializable {

	public StandardTermSearch() {}
	
	public StandardTermSearch(StandardTerm term) {
		this.termSeqs = Long.toString(term.getTermSeq());
		this.korean = term.getKorean();
		this.english = term.getEnglish();
		this.englishAbbr = term.getEnglishAbbr();
		this.standardTermList.add(term);
	}
	
	public StandardTermSearch(String termSeqs, String korean, String english, String englishAbbr, List<StandardTerm> standardTermList) {
		this.termSeqs = termSeqs;
		this.korean = korean;
		this.english = english;
		this.englishAbbr = englishAbbr;
		this.standardTermList = standardTermList;
	}
	
	/**
	 * 시리얼 버전
	 */
	private static final long serialVersionUID = 1L;
	
	private String termSeqs;
	
	/**
	 * 표준용어 한글
	 */
	private String korean;

	/**
	 * 표준용어 영어
	 */
	private String english;
	
	/**
	 * 표준용어 영어 약어
	 */
	private String englishAbbr;
	
	/**
	 * 표준용어 목록
	 */
	private List<StandardTerm> standardTermList = new ArrayList<StandardTerm>();

	
	public String getTermSeqs() {
		return termSeqs;
	}

	public void setTermSeqs(String termSeqs) {
		this.termSeqs = termSeqs;
	}

	public String getKorean() {
		return korean;
	}

	public void setKorean(String korean) {
		this.korean = korean;
	}

	public String getEnglish() {
		return english;
	}

	public void setEnglish(String english) {
		this.english = english;
	}

	public String getEnglishAbbr() {
		return englishAbbr;
	}

	public void setEnglishAbbr(String englishAbbr) {
		this.englishAbbr = englishAbbr;
	}

	public List<StandardTerm> getStandardTermList() {
		return standardTermList;
	}

	public void setStandardTermList(List<StandardTerm> standardTermList) {
		this.standardTermList = standardTermList;
	}

}
