package com.takensoft.taken_bi_manager.user.member.servie;

import java.util.HashMap;
import java.util.List;

import com.takensoft.taken_bi_manager.common.vo.CheckMessage;
import com.takensoft.taken_bi_manager.common.vo.CommonVO;
import com.takensoft.taken_bi_manager.common.vo.CustomeResultMap;
import com.takensoft.taken_bi_manager.common.vo.SearchVO;
import com.takensoft.taken_bi_manager.user.member.vo.Member;

public interface MemberService {
	    
    /**
	 * @author 김성원
	 * @since 2024.01.09
	 * 
	 * 아이디로 멤버조회(userId)
	 */
	public Member getMemnberById(String userId) throws Exception;	
	
	/**
	 * @author 김성원
	 * @since 2024.01.09
	 * 
	 * 회원가입(userId)
	 */
	public Member insertMember(Member member) throws Exception;	
	
	/**
	 * @author 김성원
	 * @since 2024.01.10
	 * 
	 * 회원정보 업데이트(Member)
	 */
	public Member updateMember(Member member) throws Exception;
	
	/**
	 * @author 김성원
	 * @since 2024.01.10
	 * 
	 * 회원삭제(Member)
	 */
	public Member deleteMember(Member member) throws Exception;

	/**
	 * @author 김성원
	 * @since 2024.01.09
	 * 
	 * 회원가입(userId)
	 */
	public List<Member> selectMemberList(SearchVO searchVO) throws Exception;	
	
	/**
	 * @author 김성원
	 * @since 2024.01.09
	 * 
	 * 회원가입(userId)
	 */
	public long selectMemberListCount(SearchVO searchVO) throws Exception;		
	
	/**
	 * @author 김성원
	 * @since 2024.01.10
	 * 
	 * 회원권한 부여(Member)
	 */
	public Member insertMemberAuth(Member member) throws Exception;
	
	/**
	 * @author 김성원
	 * @since 2024.01.10
	 * 
	 * 회원권한 삭제(Member)
	 */
	public Member deleteMemberAuth(Member member) throws Exception;	
	
	
	
}
