package com.takensoft.taken_bi_manager.user.member.vo;

import java.sql.Date;
import java.sql.Timestamp;
import java.util.List;

import com.takensoft.taken_bi_manager.common.util.CryptoUtil;

import lombok.Getter;
import lombok.Setter;

/**
 * @author 김성원
 * @since 2023-12-28
 * 
 * 회원정보 객체 
 */
@Getter
@Setter
public class Member {

	// 사용자 ID
	private String userId;
	
	// 사용자 비밀번호
	private String userPassword;
	
	// 사용자 이름
	private String userNm;
	
	// 사용자 이메일
	private String userEmail;
	
	// 사용자 전화번호
	private String userTel;
	
	// 사용자 휴대폰 번호
	private String userPhone;
	
	// 사용자 우편번호
	private String zipCode;
	
	// 사용자 주소 
	private String adres;
	
	// 사용자 상세주소 
	private String adresDetail;
	
	// 사용자 성별 
	private String gender;
	
	// 사용자 생년월일
	private Date BirthDt;
	
	// 생성일
	private Timestamp creatDt;
	
	// 생성자ID
	private String creatId;
	
	// 수정일 
	private Timestamp updtDt;
		
	// 수정자 ID
	private String updtId;
	
	// 사용자 로그인 잠김 여부 
	private boolean lockAt;
	
	// 사용자 로그인 잠김 일시
	private Timestamp lockDt;
	
	// 사용자 로그인 실패 카운트 
	private int loginFailrCnt;	
	
	// 현재 부서명  
	private String deptNm;
	
	// 권한 리스트 
	private List<String> authList;
	
	
	/**
	 * @author 김성원
	 * @since 2024.01.09
	 * 
	 * 사용자 비번 암호화 
	 */
	public void PasswordEncoder() {
		this.userPassword = CryptoUtil.PasswordEncoder(this.userPassword);
	}
	
	/**
	 * @author 김성원
	 * @since 2024.01.09
	 * 
	 * 사용자 정보 암호화 
	 */
	public void dataEncoder() {		
		this.userPhone = CryptoUtil.encryptData(this.userPhone);
		this.userTel = CryptoUtil.encryptData(this.userTel);
		this.userEmail = CryptoUtil.encryptData(this.userEmail);
		this.adres = CryptoUtil.encryptData(this.adres);
		this.adresDetail = CryptoUtil.encryptData(this.adresDetail);
	}
	
	/**
	 * @author 김성원
	 * @since 2024.01.09
	 * 
	 * 사용자 정보 복호화 
	 */
	public void dataDecoder() {		
		this.userPhone = CryptoUtil.decryptData(this.userPhone);
		this.userTel = CryptoUtil.decryptData(this.userTel);
		this.userEmail = CryptoUtil.decryptData(this.userEmail);
		this.adres = CryptoUtil.decryptData(this.adres);
		this.adresDetail = CryptoUtil.decryptData(this.adresDetail);
	}
	
	
}
